/*
About this program:
This program is used to design High Pass FIR filter with given cutoff
and sampling frequency.
The user has to input the sampling frequency, cutoff frequency, Number
of coefficients for the filter, and the window function to be applied
to the filter coefficients.
The program is same as lpf.c only equation is different.
*/

#include<stdio.h>
#include<conio.h>
#include<graphics.h>
#include<math.h>
#include<stdlib.h>
#include<dos.h>
main()
{
        int n,i,j,k,coeff;
        float fn,r1,r2,f1,f2,fs,r,c[26],a[26];
	float w[100],Pi;
	FILE *f;

        Pi = 22.0/7.0;
        /*----------------------------------------*/
        clrscr();
        for(i=0;i<80;i++)
                printf("");
        printf("\t\t HighPass FIR filter design.\n");
        for(i=0;i<80;i++)
                printf("");
        /*-----------------------------------------*/

        /*
        Get the cutoff frequency, sampling frequency.
        */
        printf("\n Input the value of cut off frquency: ");
        scanf("%f",&f1);
        printf("\n Input the value of Sampling Frequency(fs): ");
        scanf("%f",&fs);
        printf("\n Input the no. of coefficients: ");
        scanf("%d",&coeff);
        fn=fs/2;
        r1=f1/fn;
        r2=1;
        n=(coeff-1)/2;
        c[0]=r2-r1;
        /*
        Calculate the coefficients and repeat them on the negative side.
        */
        for(i=1;i<=n;i++)
		c[i]=(sin(r2*i*Pi)-sin(r1*i*Pi))/(i*Pi);
        for(i=0;i<=2*n;i++)
        {
                j=n-i;
                if(j < 0)
                        j=-1*j;
                a[i]=c[j];
        }

        /*
        Write the coefficients to the file coeff.dat
        */
        f=fopen("coeff.dat","w");
        fprintf(f,"%d\n",coeff);
        fprintf(f,"0\n");
        for(i=0;i<2*n;i++)
                fprintf(f,"%f\n",a[i]);
        fprintf(f,"%f",a[i]);
        rewind(f);
        fclose(f);
}
