/*
About this program:
This program is used to calculate the Z transform of a sequence.
The user has to input the length of the sequence and the values. the user
has to input the starting point also.
The Z tranform is calculated as,
        H(z) =  h(n) Z^-n
*/
#include<stdio.h>
#include<conio.h>
#include<dos.h>
#include<math.h>
int i,j,Xlen,Count;
float Signal[10],Sum;
void ReadSig();
main()
{

	int k,StrPt;
	char YesNo;
        /*
        Set input to zero.
        */
	for(i= 0; i<10; i++)
	{
                Signal[i] = 0;
	}

        /*Leave-------------------------------------*/
        clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Z Transform.\n");
        for(j = 0;j < 80;j++)
		printf("");
        /*------------------------------------------*/
        /*
        Get the length and values of the signal.
        */
	ReadSig();

        /*
        Get the starting point.
        */
	printf("Input the starting point for the Z Transform(< 10): ");
	scanf("%d",&StrPt);
	if(StrPt > 10)
	{
		printf("The starting point Can't be more than 10.");
		printf("\nExiting...");
		exit(1);
	}

        /*
        Pad zero's if starting point is greater than length of the sequence.
        */
        if(StrPt >= Xlen)
        {
		printf("\nThis will pad Zero's to the original sequence."
		"\nAre you Sure ? (y/n): ");
		fflush(stdin);
		YesNo = tolower(getche());
		printf("\n");
		if(YesNo != 'y')
		{
			printf("\nExiting...");
			exit(1);
		}
		Xlen = StrPt + 1;
        }
        /*Leave----------------------------------*/
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Z Transform. \n");
	for(j = 0;j < 80;j++)
		printf("");
        /*---------------------------------------*/
        /*
        Calculate the Z transform.
        */
	printf("\n\nThe Z Transform of the sequence is: ");
	printf("\nX(z) = ");
	for(i= 0; i< Xlen;i++)
	{
	    printf("\n%0.3f * z^ %d",Signal[i],StrPt - i);
	    if(i< Xlen - 1)
		printf(" + ");
	}
	getch();
	clrscr();
}

/*
This function is used to read the samples of the signal from the console.
Refer to Convolve.c  for explaination.
*/
void ReadSig()
{
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Z Transform.\n");
        for(j = 0;j < 80;j++)
		printf("");
	printf("Input The length of the sequence (< 10): ");
	scanf("%d",&Xlen);
	if(Xlen > 10)
	{
		printf("Can't take more than 10 inputs.");
		printf("\nExiting...");
		exit(0);
	}
	clrscr();
        for(j = 0;j < 80;j++)
		printf("");
	printf("\t\t\t\t Z Transform. \n");
        for(j = 0;j < 80;j++)
		printf("");
	fflush(stdin);
	printf("Input the seqence values: \n");
	for(i=0; i< Xlen; i++)
	{
		scanf("%f",&Signal[i]);
	}

}

